var ToodledoVars;

function Toodledo_LoadOptions() {
	if(window.arguments) ToodledoVars = window.arguments[0];
	
	var email = branch.getCharPref("toodledopref_email");
	
	document.getElementById("Toodledo-email").value = email;
	document.getElementById("Toodledo-1").checked = branch.getBoolPref("toodledopref_check1");
	document.getElementById("Toodledo-2").checked = branch.getBoolPref("toodledopref_check2");
	document.getElementById("Toodledo-3").checked = branch.getBoolPref("toodledopref_check3");
	document.getElementById("Toodledo-4").checked = branch.getBoolPref("toodledopref_check4");
	document.getElementById("Toodledo-5").checked = branch.getBoolPref("toodledopref_check5");
	document.getElementById("Toodledo-6").checked = branch.getBoolPref("toodledopref_check6");
	document.getElementById("Toodledo-7").checked = branch.getBoolPref("toodledopref_check7");
	document.getElementById("Toodledo-8").checked = branch.getBoolPref("toodledopref_check8");
	document.getElementById("Toodledo-9").checked = branch.getBoolPref("toodledopref_check9");
	document.getElementById("Toodledo-10").checked = branch.getBoolPref("toodledopref_check10");

	var password = Toodledo_GetPassword(email);
	
	document.getElementById("Toodledo-pass").value = password;
}


function Toodledo_SaveOptions() {
	var email = document.getElementById("Toodledo-email").value;
	var pass = document.getElementById("Toodledo-pass").value;
	
	if(ToodledoVars) ToodledoVars.key = null; //key is invalidated so that authentication is attempted again
	branch.setCharPref("toodledopref_email", email);
	branch.setCharPref("toodledopref_userid", ""); //when the email/password change we need to refresh the userid
	branch.setBoolPref("toodledopref_check1", document.getElementById("Toodledo-1").checked);
	branch.setBoolPref("toodledopref_check2", document.getElementById("Toodledo-2").checked);
	branch.setBoolPref("toodledopref_check3", document.getElementById("Toodledo-3").checked);
	branch.setBoolPref("toodledopref_check4", document.getElementById("Toodledo-4").checked);
	branch.setBoolPref("toodledopref_check5", document.getElementById("Toodledo-5").checked);
	branch.setBoolPref("toodledopref_check6", document.getElementById("Toodledo-6").checked);
	branch.setBoolPref("toodledopref_check7", document.getElementById("Toodledo-7").checked);
	branch.setBoolPref("toodledopref_check8", document.getElementById("Toodledo-8").checked);
	branch.setBoolPref("toodledopref_check9", document.getElementById("Toodledo-9").checked);
	branch.setBoolPref("toodledopref_check10", document.getElementById("Toodledo-10").checked);
		
	Toodledo_setPassword(pass);

	if(email && pass) {
		email = email.replace("&","%26");
		email = email.replace(";","%3B");
		email = email.replace("+","%2B");
		email = email.replace("%","%25");
		pass = pass.replace("%","%25");
		pass = pass.replace("&","%26");
		pass = pass.replace(";","%3B");
		pass = pass.replace("+","%2B");
	
		Toodledo_GetUrl(";method=getUserid;email="+email+";pass="+pass,false,"");
	} else {
		return true;
	}
	
	return false;
}

function Toodledo_UrlLoaded() {
	var res=httpRequest.responseText;
	var xml=httpRequest.responseXML;
	
	//Toodledo_Log(res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				document.getElementById("toodledo.options.error").hidden = false;
			} else if(userid==1) {
				document.getElementById("toodledo.options.error").hidden = false;
			} else {
				branch.setCharPref("toodledopref_userid", userid);
				window.close();
			}
			
		} else if(root_node=="error") {
			var error_value = xml.firstChild.textContent;
			
			if(error_value=="key did not validate") {  //perhaps the key expired. Try one more time
				if(TryOnce) {
					document.getElementById("toodledo.options.error").hidden = false;
					TryOnce=0;
				} else {
					ToodledoGetAPIKey();
					TryOnce++;
				}
				
			}
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}